package com.example.springdemo.dao;

import com.example.springdemo.entities.RBAC.RolesPermissions;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface RolesPermissionsRepository
        extends JpaRepository<RolesPermissions, Long> {
    @Modifying
    @Query(value = "delete from roles_permissions " +
            "where rolesId = ?1 and permissionsId = ?2", nativeQuery = true)
    int RemovePermissionsFromRole(Long roleId, Long permissionId);

    @Modifying
    @Query(value = "update roles_permissions set rolesId = ?1, permissionsId = ?2 " +
            "where rolesId = ?1 and permissionsId = ?2", nativeQuery = true)
    int updateRolePermissions(Long roleId, Long permissionId);

    Optional<RolesPermissions> findByRolesId(Long roleId);

    Optional<RolesPermissions> findByPermissionsId(Long permissionId);

    void deleteByRolesId(Long roleId);

    void deleteByPermissionsId(Long permissionId);
}
